org.eclipse.jgit.transport

## Class PacketLineOut

- java.lang.Object
- - org.eclipse.jgit.transport.PacketLineOut

    public class PacketLineOut
    extends Object

Write Git style pkt-line formatting to an output stream.

This class is not thread safe and may issue multiple writes to the underlying stream for each method call made.

This class performs no buffering on its own. This makes it suitable to interleave writes performed by this class with writes performed directly against the underlying OutputStream.

### Constructor Summary

Constructors
Constructor and Description
`PacketLineOut(OutputStream outputStream)` Create a new packet line writer.

### Method Summary

All Methods Instance Methods Concrete Methods
`void` `end()` Write a packet end marker, sometimes referred to as a flush command.
`void` `flush()` Flush the underlying OutputStream.
`void` `setFlushOnEnd(boolean flushOnEnd)` Set the flush behavior during `end()`.
`void` `writePacket(byte[] packet)` Write a binary packet to the stream.
`void` `writeString(String s)` Write a UTF-8 encoded string as a single length-delimited packet.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### PacketLineOut

    public PacketLineOut(OutputStream outputStream)

Create a new packet line writer.

Parameters:
  `outputStream` - stream.

### Method Detail

#### setFlushOnEnd

    public void setFlushOnEnd(boolean flushOnEnd)

Set the flush behavior during `end()`.

Parameters:
  `flushOnEnd` - if true, a flush-pkt written during `end()` also flushes the underlying stream.

#### writeString

    public void writeString(String s)
                     throws IOException

Write a UTF-8 encoded string as a single length-delimited packet.

Parameters:
  `s` - string to write.
Throws:
  `IOException` - the packet could not be written, the stream is corrupted as the packet may have been only partially written.

#### writePacket

    public void writePacket(byte[] packet)
                     throws IOException

Write a binary packet to the stream.

Parameters:
  `packet` - the packet to write; the length of the packet is equal to the size of the byte array.
Throws:
  `IOException` - the packet could not be written, the stream is corrupted as the packet may have been only partially written.

#### end

    public void end()
             throws IOException

Write a packet end marker, sometimes referred to as a flush command.

Technically this is a magical packet type which can be detected separately from an empty string or an empty packet.

Implicitly performs a flush on the underlying OutputStream to ensure the peer will receive all data written thus far.

Throws:
  `IOException` - the end marker could not be written, the stream is corrupted as the end marker may have been only partially written.

#### flush

    public void flush()
               throws IOException

Flush the underlying OutputStream.

Performs a flush on the underlying OutputStream to ensure the peer will receive all data written thus far.

Throws:
  `IOException` - the underlying stream failed to flush.